// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/IRenderHost.hpp"
#include <glad/glad.h>
#include <GLFW/glfw3.h>

#define DAWN_GLFW_WINDOW_WIDTH_DEFAULT 1280
#define DAWN_GLFW_WINDOW_HEIGHT_DEFAULT 720

namespace Dawn {
  class Game;

  class RenderHost : public IRenderHost {
    public:
      GLFWwindow *window = nullptr;

      /**
       * Initializes the GLFW RenderHost.
       */
      RenderHost();

      void init(std::shared_ptr<Game> game) override;

      void update() override;
    
      bool_t isCloseRequested() override;

      ~RenderHost();
  };
}